
function Main()
#ifndef FWVERSION
   ErrorBlock( { | oError | MsgInfo( GetErrorInfo( oError ),;
                                     ProcName( 1 ) + "(" + AllTrim( Str( ProcLine( 1 ) ) ) + ")" ) } ) 
#endif
cls

   /*
    * Try to change the SQLWIN.PRG on line 107 to work with POSTGRESQL and recompile
    * this test, please.
    */
   DbCreate( "test.dbf", { { "first", "C", 10, 0 },;
                           { "last",  "C", 10, 0 },;
                           { "age",   "N",  3, 0 },;
                           { "data",  "D", 10, 0 } }, "SQLWIN" )
                           
   USE test VIA "SQLWIN"  
   
   MsgInfo( "Alias: " + Alias() ) 
   MsgInfo( test->( FieldName( 1 ) ) )                     

   GOTO 10
   
   test->first = "Paul"
   FieldPut( 2, "Smith" )
   FieldPut( FieldPos( "data" ), DATE() )
   COMMIT
   
   GOTO BOTTOM
   
   MsgInfo( RecNo(), 'Recno()' )
   MsgInfo( RecCount(), 'RecCount()' )
  
  /*
   * Note que SET DELETED affect theses functions
   *//*
   SET DELETED ON
   MsgInfo( RecNo(), 'Recno()' )
   MsgInfo( RecCount(), 'RecCount()' )
  */ 
   APPEND BLANK
   test->first = "Paul's"
   FieldPut( 2, "Smith" )
   FieldPut( FieldPos( "data" ), CTOD("") )
   COMMIT
   
   MsgInfo( test->First, "test->First" )
   MsgInfo( RecCount(), 'RecCount()' )
   
   PACK                                               
   ZAP
   
return nil      

function GetErrorInfo( oError )

   local cInfo := "ERROR" + Chr( 13 ) + Chr( 10 ), n
   
   cInfo += "Description: " + oError:Description + Chr( 13 ) + Chr( 10 )
   cInfo += "GenCode: " + AllTrim( Str( oError:genCode ) ) + Chr( 13 ) + Chr( 10 )
   cInfo += "Operation: " + oError:Operation + Chr( 13 ) + Chr( 10 )
   
   if ValType( oError:Args ) == "A"
      for n = 1 to Len( oError:Args )
          cInfo += "Args[" + AllTrim( Str( n ) ) + "] " + cValToChar(oError:Args[ n ]) + Chr( 13 ) + Chr( 10 )
      next
   endif       
   
return cInfo                      

#ifndef FWVERSION
/*
 * Only for console mode tests...
 */
function  MsgInfo(x,y)
   x := strtran( cValToChar(x), chr(13)+chr(10), ';;')
   if y == nil
      alert(x)
   else
      alert(y+":;;"+x)
   end
   return 0
   
function cValToChar( uVal )

   local cType := ValType( uVal )

   do case
      case cType == "C" .or. cType == "M"
           return uVal

      case cType == "D"
           return DToC( uVal )

      case cType == "L"
           return If( uVal, ".T.", ".F." )

      case cType == "N"
           return AllTrim( Str( uVal ) )

      case cType == "B"
           return "{|| ... }"

      case cType == "A"
           return "{ ... }"

      case cType == "U"
           return "NIL"

      case cType == "O"
           return "Object"

      otherwise
           return ""
   endcase

return nil   
#endif
